import pytest
from .. import base
from time import sleep
import requests

"""

Hash comments here. 
What does the code below do?

"""

@base.bootstrapped
@pytest.mark.asyncio
async def test_postgresqlrelation():
    async with base.CleanModel() as model:

        print('deploying zookeeper')
        unit_zookeeper = await model.deploy('zookeeper')

        print('deploying postgresql')
        unit_postgresql = await model.deploy('postgresql', series="xenial")

        print('deploying apache-drill')
        unit_drill = await model.deploy('~spiculecharms/apache-drill', channel="edge")  # noqa

        await unit_zookeeper.add_relation('zookeeper', 'apache-drill')
        print('blocking until services are ready')
        await model.block_until(
            lambda: (
                    len(unit_drill.units) > 0 and
                    unit_drill.units[0].workload_status_message ==
                    "Apache Drill up and running." and
                    "Live master" in unit_postgresql.units[0].workload_status_message and
                    unit_zookeeper.units[0].public_address is not None
            )
        )

        ip_drill = unit_drill.units[0].public_address
        print('checking storage page for previous postgresql sources')
        r = base.check_statuscode(10, 'http://' + ip_drill + ':8047/storage.json')

        found = base.check_jsonresponse('psql', 'name', 'http://' + ip_drill + ':8047/storage.json', 10)

        if not found:
            assert True
        else:
            assert False

        await unit_postgresql.add_relation('db', 'apache-drill')
        print('checking storage page for new postgresql sources')
        r = base.check_statuscode(10, 'http://' + ip_drill + ':8047/storage.json')

        found = base.check_jsonresponse('psql', 'name', 'http://' + ip_drill + ':8047/storage.json', 240)

        if not found:
            assert False
        else:
            assert True