import pytest
from .. import base
import time

@base.bootstrapped
@pytest.mark.asyncio
async def test_zkmetric():
    async with base.CleanModel() as model:

        print('deploying zookeeper')
        unit_zookeeper = await model.deploy('zookeeper')

        await model.block_until(
            lambda: (
                    unit_zookeeper.units[0].workload_status == 'active'
            )
        )

        metrics = {}
        attempt = 0
        while not metrics and attempt < 10:
            metrics = await (model.get_metrics())
            attempt += 1
            if not metrics:
                time.sleep(300)

        value = metrics.get("zookeeper/0")
        for item in value:
            if item.get("key") == "peers":
                assert int(item.get('value')) > 0