import unittest
import amulet


class TestDeployment(unittest.TestCase):

    @classmethod
    def setUpClass(cls):
        cls.d = amulet.Deployment(series='trusty')

        cls.d.add('mysql')
        cls.d.add('mediawiki')
        cls.d.add('haproxy')

        # set up service relations
        cls.d.relate('mysql:db', 'mediawiki:db')
        cls.d.relate('mediawiki:website', 'haproxy:reverseproxy')

        # change some configuration on mediawiki
        cls.d.configure('mediawiki', {
            'title': 'My Wiki',
            'skin': 'Nostolgia',
        })

        cls.d.expose('haproxy')

        cls.d.setup()
        cls.d.sentry.wait()


if __name__ == '__main__':
    unittest.main()